/*
 *   metatemplate.c
 *   metatemplate Vers. 0.10.0
 *                    Copyright (C)  2002-2010  Matteo Nastasi
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *     CONTACT:    nastasi@alternativeoutput.it
 *                 matteo.nastasi@milug.org
 *
 */

/*
 * TODO:
 *    verificare se e' corretto pensare che il nome del file da includere
 *    e' tirato dentro in una botta sola 
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "ffilter.h"

#define OUTPHP "./Pho"
#define OUTTEM "./Template"
#define OUTPRE "./Preview"
#define OUTOBJ "./Obj"

#define ST_FUORI 0
#define ST_HDINC 1
#define ST_HDOBJ 2
#define ST_INOBJ 3
#define ST_ININC 4
#define ST_HDELE 5
#define ST_HDELO 6
#define ST_INELE 7
#define ST_HDGTO 8

/*
  bla bla bla
<!--MIOBJ:nomeoggetto--> 
   <!--MI:nomeelemento--> elemento <!--/MI-->
   <!--MI:nomeelemento2--> elemento2 <!--/MI-->
   <!--MO:nomeelemento2-->Oggetto senza riferimento nel template<!--/MO-->
   <!--MI:#--> parte solamente per preview <!--/MI-->
   <!--MI:nomeelemento2--> elemento2 <!--/MI-->  
   ....
  <!--MI:nomeelementoN--> elementoN <!--/MI-->  
  ble ble ble
  ...........
  blu blu blu
<!--/MIOBJ-->
  ...........
<!--MINCL:nomeinclude-->
  ...........
  bli bli bli
<!--/MINCL-->
  ...........
  blo blo blo
<!--MIGTO:nomeoggetto--> 
  blu blu blu
  ...........
 */

/* -- primo passaggio per estrarre le include definite nel sorgente -- */
#define W_PREOPINCL      0
#define W_PRECLINCL      1
char *keyprest[] = { "\n<!--MINCL:", "<!--/MINCL-->\n", NULL };

#define W_PRECLOSEI      0
char *keyprecl[] = { "-->", NULL };

/* -- secondo passaggio per il resto -- */
#define W_OPENMIGTO      0
#define W_OPENMINCL      1
#define W_CLOSMINCL      2
#define W_OPENMI         3
#define W_OPENMO         4

#define W_OPENMIOBJ      3
char *keyout[] = { "\n<!--MIGTO:", "\n<!--MINCL:", "<!--/MINCL-->\n", "\n<!--MIOBJ:", NULL };

#define W_CLOSETAG       0
char *keyclose[] = { "-->", NULL };

#define W_CLOSMIOBJ      5
char *keyele[] = { "\n<!--MIGTO:", "\n<!--MINCL:", "<!--/MINCL-->\n",
                   "\n<!--MI:",    "\n<!--MO:", 
                   "<!--/MIOBJ-->\n", NULL };

#define W_CLOSMI         5
#define W_CLOSMO         6
char *keyclele[] = { "\n<!--MIGTO:", "\n<!--MINCL:", "<!--/MINCL-->\n", 
		     "\n<!--MI:",    "\n<!--MO:", 
		     "<!--/MI-->\n", "<!--/MO-->\n", NULL };

#define NMAXFINC        16
FILE *fobji[NMAXFINC];
FILE *fobjp[NMAXFINC];
FILE *fobjt[NMAXFINC];
int nfinc = 0;

#define NMAXELE         16
#define LENMXELE     (10240 * 50)
char elem[NMAXELE][LENMXELE];
char eprefix[256];
int elempref[NMAXELE],dummy[NMAXELE],nelem = 0;


void appendfile(FILE *fap,FILE *fin)
{
  int c;

  while ((c = fgetc(fin)) != EOF)
    fputc(c,fap);
}

char *addslash(char *s)
{
  static char bf[2048];
  char *p = bf;

  for (; *s ; s++) {
    if (*s == '\'' || *s == '\\') 
      *p++ = '\\';
    *p++ = *s;
  }
  *p = '\0';
  // fprintf(stderr,"ADDSLA[%s]\n", bf);
  return (bf);
}

char *tomaiu(char *s)
{
  static char bf[2048];
  char *p = bf;

  for (; *s ; s++,p++)
    *p = toupper(*s);
  *p = '\0';
  
  return (bf);
}      

void outspace(FILE *fp,int nele)
{
  int i;

  for (i = 0 ; i < (nele*3) ; i++)
    fputc(' ',fp);
}

void outtag(FILE *fp,char *s,int nele)
{
  static int st = 0, c = 0;
  static char bf[512];
  int i;

  for (i = 0 ; s[i] != '\0' ; i++) {
    switch(st) {
    case 0:
      if (s[i] == '#') {
	bf[0] = '#';
	c = 1;
	st = 1;
      }
      break;
    case 1:
      if (isalnum(s[i]) || s[i] == '_') 
	bf[c++] = s[i];
      else if (s[i] == '#') {
	if (c == 1)
	  break;
	bf[c++] = '#';
	bf[c++] = '\0';
	outspace(fp,nele);
	fprintf(fp,"%s\n",tomaiu(bf));
	st = 0;
      }
      else 
	st = 0;
      break;
    }
  }
}

int main(int argc, char **argv)
{
  FIFILE *ff;
  FILE *fpho,*ftemp,*fprev;
  FILE *fpinfo;

  char nome[256],bf[256],srcfile[512],nomefile[512],nomeobj[256],maiuobj[256];
  int i,n,k,st = ST_FUORI,inobj = 0;
  int nextst;
  char **nextkeys;

  fpinfo = stdout;

  if (argc != 2)
    exit(1);

  eprefix[0] = '\0';
  strcpy(nome,argv[1]);
  for (n = 0 ; nome[n] != '.' && nome[n] != '\0' ; n++);
  if (nome[n] == '\0') 
    sprintf(srcfile,"%s.html",nome);
  else {
    strcpy(srcfile,nome);
    nome[n] = '\0';
  }

  fprintf(fpinfo,"-------- includes creation --------\n");
/* -- PRIMO PASSAGGIO PER ESTRARRE LE INCLUDE DEFINITE NEL SORGENTE -- */
  /* sprintf(nomefile,"%s.html",nome); */
  if ((ff = ffopen(srcfile,keyprest)) == NULL)
    exit(2);
  while ((n = ffgetbin(bf,255,ff)) > -1) {
    k = ffkstat(ff);
    switch(st) {
    case ST_FUORI:
      for (i = 0 ; i < nfinc ; i++) 
	fprintf(fobji[i],"%s",bf);
      if (k == W_PREOPINCL) {
	st = ST_HDINC;
	ffchankeys(ff,keyprecl);
      }
      else if (k == W_PRECLINCL) {
	if (nfinc == 0)
	  exit(3);
	nfinc--;
	fclose(fobji[nfinc]);
      }
      break;
    case ST_HDINC:
      if (nfinc == NMAXFINC || k != W_PRECLOSEI) {
	exit(4);
      }
      sprintf(nomefile,"%s/%s.inc",OUTOBJ,bf);
      if ((fobji[nfinc] = fopen(nomefile,"w")) == NULL)
	exit (5);
      fprintf(fpinfo,"created [%s]\n",nomefile);
      nfinc++;
      st = ST_FUORI;
      ffchankeys(ff,keyprest);
      break;
    }
  }
  if (nfinc != 0)
    exit(6);
  ffclose(ff);

  /* -- SECONDO PASSAGGIO PER IL RESTO -- */
  fprintf(fpinfo,"-------- objects creation  --------\n");
  /* sprintf(nomefile,"%s.html",nome); */
  if ((ff = ffopen(srcfile,keyout)) == NULL)
    exit(7);
  sprintf(nomefile,"%s/%s.tmpl",OUTTEM,nome);
  if ((ftemp = fopen(nomefile,"w")) == NULL)
    exit(8);
  sprintf(nomefile,"%s/%s.php",OUTPRE,nome);
  if ((fprev = fopen(nomefile,"w")) == NULL)
    exit(9);
  st = ST_FUORI;
  while ((n = ffgetbin(bf,255,ff)) > -1) {
    //    fprintf(stderr,"BIN [%s]\n",bf);
    k = ffkstat(ff);
    // fprintf(stderr,"BF: [%s]  K: %d\n",bf,k);

    switch(st) {
    case ST_FUORI:
      outtag(fpinfo,bf,nelem + inobj);
      fprintf(ftemp,"%s",bf);
      fprintf(fprev,"%s",bf);
      if (k == W_OPENMIOBJ) {
	st = ST_HDOBJ;
	ffchankeys(ff,keyclose);
      }
      else if (k == W_OPENMIGTO || k == W_OPENMINCL) {
	nextst = st;
	nextkeys = ffgetkeys(ff);
	ffchankeys(ff,keyclose);      
	if (k == W_OPENMIGTO)
	  st = ST_HDGTO;
	else
	  st = ST_HDINC;
      }
      break;
    case ST_HDGTO:
      sprintf(nomefile,"%s/%s.inc",OUTOBJ,bf);
      if (!ffinclude(ff,nomefile)) {
	fprintf(stderr,"Non trovato il file da includere %s\n",nomefile);
	exit (10);
      }
      /* PIPPO CHECK */
      if (k == W_CLOSETAG) {
	st = nextst;	
	ffchankeys(ff,nextkeys);
      }
      break;

    case ST_HDINC:
      /* PIPPO CHECK */
      if (k == W_CLOSETAG) {
	st = nextst;	
	ffchankeys(ff,nextkeys);
      }
      break;


    case ST_HDOBJ:
      strcpy(nomeobj,bf);
      strcpy(maiuobj,tomaiu(nomeobj));
      sprintf(nomefile,"%s/%s.pho",OUTPHP,bf);
      if ((fpho = fopen(nomefile,"w")) == NULL)
	exit (11);
      fprintf(fpho,"<?php /* generated from file \"%s.html\" */\n",nome);
      fprintf(fpho,"  $%s = array();\n",nomeobj);
      fprintf(fpinfo,"obj: %s\n",bf);
      // inobj = 1;
      /* PIPPO CHECK */
      if (k == W_CLOSETAG) {
	st = ST_INOBJ;
	ffchankeys(ff,keyele);
      }
      break;
    case ST_INOBJ:
      outtag(fpinfo,bf,nelem + inobj);
      fprintf(ftemp,"%s",bf);
      fprintf(fprev,"%s",bf);
      if (k == W_OPENMI) {
	st = ST_HDELE;
	ffchankeys(ff,keyclose);
      }
      else if (k == W_OPENMO) {
	st = ST_HDELO;
	ffchankeys(ff,keyclose);
      }
      else if (k == W_CLOSMIOBJ) {
	fprintf(fpho,"?>");
	fclose(fpho);

	st = ST_FUORI;
	ffchankeys(ff,keyout);
	inobj = 0;
	fprintf(fpinfo,"obj close\n");
      }
      else if (k == W_OPENMIGTO || k == W_OPENMINCL) {
	nextst = st;
	nextkeys = ffgetkeys(ff);
	ffchankeys(ff,keyclose);      
	if (k == W_OPENMIGTO)
	  st = ST_HDGTO;
	else
	  st = ST_HDINC;
      }
      break;
    case ST_HDELE:
    case ST_HDELO:
      if (!strcmp(bf,"#")) {
	dummy[nelem] = 1;
	outspace(fpinfo,nelem + inobj);
	fprintf(fpinfo,"ele dummy:[%s]\n",bf);
      }
      else {
	dummy[nelem] = 0;
	elempref[nelem] = strlen(eprefix);
	if (nelem == 0) {
	  /* strcpy(eprefix,nomeobj);
	     strcat(eprefix,"_"); */
	  strcpy(eprefix,bf);
	  if (st == ST_HDELE) {
	    fprintf(ftemp,"#%s_%s#",maiuobj,tomaiu(eprefix));
	  }
	  outspace(fpinfo,nelem + inobj);
	  if (st == ST_HDELE) 
	    printf("#%s_%s# ele:[%s]\n",
		   maiuobj,tomaiu(eprefix),eprefix);
	  else
	    printf("ele:[%s] virtual\n",eprefix);
	}
	else {
	  strcat(eprefix,"_");
	  strcat(eprefix,bf);
	  outspace(fpinfo,nelem + inobj);
	  if (st == ST_HDELE) 
	    printf("#%s# ele:[%s]\n",
		   tomaiu(eprefix),eprefix);
	  else
	    printf("ele:[%s] virtual\n",eprefix);
	}
	

	if (nelem > 0) {
	  if (st == ST_HDELE) {
	    sprintf(bf,"#%s#",tomaiu(eprefix));
	    strcat(elem[nelem-1],bf);
	  }
	}
	sprintf(elem[nelem],"  $%s['%s'] = '",nomeobj,eprefix);
      }
      nelem++;
      
/* magari lo mettiamo nella chiusura 
	if (st == ST_HDELE) {
	  fprintf(ftemp,"#%s_%s#",maiuobj,tomaiu(bf));
	}
*/
      /* PIPPO CHECK */
      if (k == W_CLOSETAG) {
	st = ST_INELE;
	ffchankeys(ff,keyclele);
      }
      break;
    case ST_INELE:
      outtag(fpinfo,bf,nelem + inobj);
      fprintf(fprev,"%s",bf);
      if (!dummy[nelem-1])
	strcat(elem[nelem-1],addslash(bf));

      if (k == W_OPENMI) {
	st = ST_HDELE;
	ffchankeys(ff,keyclose);
      }
      else if (k == W_OPENMO) {
	st = ST_HDELO;
	ffchankeys(ff,keyclose);
      }
      else if (k == W_CLOSMI || k == W_CLOSMO) {
	nelem--;
	outspace(fpinfo,nelem + inobj);
	fprintf(fpinfo,"ele close\n");
	if (!dummy[nelem]) {
	  strcat(elem[nelem],"';\n");
	  fputs(elem[nelem],fpho);
	  eprefix[elempref[nelem]] = '\0';
	}
	if (nelem == 0) {
	  st = ST_INOBJ;
	  ffchankeys(ff,keyele);
	}
      }
      else if (k == W_OPENMIGTO || k == W_OPENMINCL) {
	nextst = st;
	nextkeys = ffgetkeys(ff);
	ffchankeys(ff,keyclose);      
	if (k == W_OPENMIGTO)
	  st = ST_HDGTO;
	else
	  st = ST_HDINC;
      }
      break;
    }
  }
  fclose(ftemp);
  fclose(fprev);
  ffclose(ff);
      
  exit(0);
  return (1);
}
